/*
sbit clk at RD1_bit;
sbit data_ at RD0_bit;

void IntToLcd(int integer);
void gotoXy(unsigned char  ,unsigned char);
void lcdInit(void);
void lcdCmd(unsigned char);
void lcddata_(unsigned char);
void lcdWriteNibble(unsigned char);
void waitLcd(int);
void waitUs(int);
void prints(char *message);

unsigned char rs;
unsigned char msg1[] = "Hello";
unsigned char msg2[] = "Serial";
unsigned char msg3[] = "LCD";
unsigned char msg4[] = "20X4";

void lcdWriteNibble(unsigned char d)
{
unsigned char i;
clk = 0;
data_= 0;
for(i=0;i<8;i++)
        {
        waitUs(10);
        clk = 1;
        waitUs(10);
        clk = 0;
        waitUs(10);
        }

data_ = 1;                                        //set Q7= 1 for E
waitUs(10);
clk =1;
waitUs(10);
clk=0;
waitUs(10);

data_ = rs;                                //set Q6 for RS
waitUs(10);
clk =1;
waitUs(10);
clk =0;
waitUs(10);

        for ( i=8;i>0;i=i>>1)
        {
                if(d & i)
                        {
                                data_ =1;
                        }
                        else
                        {
                                data_ =0;
                        }
                waitUs(10);
                clk = 1;
                waitUs(10);
                clk = 0;
        }

data_=0;                        //shift Q0
waitUs(10);
clk = 1;
waitUs(10);
clk = 0;
waitUs(10);

data_ = 1;                //now send enable
waitUs(100);
data_ = 0;
}


void lcdCmd(unsigned char byte)
{
rs=0; //because sending command

lcdWriteNibble(byte>>4);
waitUs(10);
lcdWriteNibble(byte & 0x0F);



}

void lcddata_(unsigned char byte)
{

rs=1;  //because sending data_

lcdWriteNibble(byte>>4);
waitUs(10);
lcdWriteNibble(byte & 0x0F);


}

void lcdInit(void)
{
rs=0;
waitLcd(40);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(2);
lcdWriteNibble(0x02);

lcdCmd(0x28);   //set data_ length 4 bit 2 line
waitLcd(50);
lcdCmd(0x0C);   // set display on cursor oFF blink off to on the cursor E to and on the blink F
waitLcd(50);
lcdCmd(0x01); // clear lcd
waitLcd(50);
lcdCmd(0x06);  // cursor shift direction
waitLcd(50);
lcdCmd(0x0C);
waitLcd(50);
lcdCmd(0x80);  //set ram address
waitLcd(50);
}

void waitLcd(int x)
{
unsigned char i;
for (x ;x>1;x--)
{
for (i=0;i<=10;i++);
}
}

void waitUs(int x)
{
unsigned char i ;
for (x ;x>1;x--)
{
for (i=0;i<=10;i++);
}
}


void gotoXy(unsigned char  x,unsigned char y)
{
 if(x<40)
 {
  if(y) x|=0b01000000;
  x|=0b10000000;
  lcdCmd(x);
  }
}







void prints(char *message){        // Write message to LCD (C string type)
//lcdCmd(0x08); // disable display;
                while (*message){                        // Look for end of string
                                        lcddata_(*message++);
                                        }
        //lcdCmd(0x0C); // enable display;
        }




void IntToLcd(int integer)   //this routine will print any int to lcd directly
{
        //        Break down the original number into the thousands, hundreds, tens,
        //        and ones places and then immediately write that value to the LCD
unsigned char thousands        ,hundreds,tens,ones;
thousands = integer / 1000;

    lcddata_(thousands + 0x30);

         hundreds = ((integer - thousands*1000)-1) / 100;

        lcddata_( hundreds + 0x30);
tens=(integer%100)/10;

        lcddata_( tens + 0x30);
        ones=integer%10;

        lcddata_( ones + 0x30);
}


void clearLcd(void)
{
        //        Send command to LCD (0x01)
        lcdCmd(0x01);
}



void main() {

     TRISD = 0x00;
     PORTD = 0x00;

     lcdInit();
     gotoXy(3,0);
     prints(&msg1);
     gotoXy(3,1);
     prints(&msg2);
     lcdCmd(0x94);
     prints(&msg3);
     lcdCmd(0xD4);
     prints(&msg4);

     while(1){
            ;
     }

}
*/
sbit clk at RD1_bit;
sbit data_ at RD0_bit;

void IntToLcd(int integer);
void gotoXy(unsigned char  ,unsigned char);
void lcdInit(void);
void lcdCmd(unsigned char);
void lcddata_(unsigned char);
void lcdWriteNibble(unsigned char);
void waitLcd(int);
void waitUs(int);
void prints(char *message);

unsigned char rs;
unsigned char msg1[] = "Hello";
unsigned char msg2[] = "Serial";
unsigned char msg3[] = "LCD";
unsigned char msg4[] = "20X4";

void lcdWriteNibble(unsigned char d)
{
unsigned char i;
clk = 0;
data_= 0;
for(i=0;i<8;i++)
        {
        clk = 1;
        clk = 0;
        }

data_ = 1;                                        //set Q7= 1 for E
clk =1;
clk=0;

data_ = rs;                                //set Q6 for RS
clk =1;
clk =0;

        for ( i=8;i>0;i=i>>1)
        {
                if(d & i)
                        {
                                data_ =1;
                        }
                        else
                        {
                                data_ =0;
                        }
                //waitUs(10);
                clk = 1;
                //waitUs(10);
                clk = 0;
        }

data_=0;                        //shift Q0
clk = 1;
clk = 0;


data_ = 1;                //now send enable
data_ = 0;
}


void lcdCmd(unsigned char byte)
{
rs=0; //because sending command

lcdWriteNibble(byte>>4);
lcdWriteNibble(byte & 0x0F);



}

void lcddata_(unsigned char byte)
{

rs=1;  //because sending data_

lcdWriteNibble(byte>>4);
//waitUs(10);
lcdWriteNibble(byte & 0x0F);


}

void lcdInit(void)
{
rs=0;
waitLcd(40);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(2);
lcdWriteNibble(0x02);

lcdCmd(0x28);   //set data_ length 4 bit 2 line
waitLcd(50);
lcdCmd(0x0C);   // set display on cursor oFF blink off to on the cursor E to and on the blink F
waitLcd(50);
lcdCmd(0x01); // clear lcd
waitLcd(50);
lcdCmd(0x06);  // cursor shift direction
waitLcd(50);
lcdCmd(0x0C);
waitLcd(50);
lcdCmd(0x80);  //set ram address
waitLcd(50);
}

void waitLcd(int x)
{
unsigned char i;
for (x ;x>1;x--)
{
for (i=0;i<=10;i++);
}
}

void waitUs(int x)
{
unsigned char i ;
for (x ;x>1;x--);
//{
//for (i=0;i<=10;i++);
//}
}


void gotoXy(unsigned char  x,unsigned char y)
{
 if(x<40)
 {
  if(y) x|=0b01000000;
  x|=0b10000000;
  lcdCmd(x);
  }
}







void prints(char *message){        // Write message to LCD (C string type)
//lcdCmd(0x08); // disable display;
                while (*message){                        // Look for end of string
                                        lcddata_(*message++);
                                        }
        //lcdCmd(0x0C); // enable display;
        }




void IntToLcd(int integer)   //this routine will print any int to lcd directly
{
        //        Break down the original number into the thousands, hundreds, tens,
        //        and ones places and then immediately write that value to the LCD
unsigned char thousands        ,hundreds,tens,ones;
thousands = integer / 1000;

    lcddata_(thousands + 0x30);

         hundreds = ((integer - thousands*1000)-1) / 100;

        lcddata_( hundreds + 0x30);
tens=(integer%100)/10;

        lcddata_( tens + 0x30);
        ones=integer%10;

        lcddata_( ones + 0x30);
}


void clearLcd(void)
{
        //        Send command to LCD (0x01)
        lcdCmd(0x01);
}



void main() {

     TRISD = 0x00;
     PORTD = 0x00;

     lcdInit();
     gotoXy(3,0);
     prints(&msg1);
     gotoXy(3,1);
     prints(&msg2);
     lcdCmd(0x94);
     prints(&msg3);
     lcdCmd(0xD4);
     prints(&msg4);

     while(1){
            ;
     }

}