#line 1 "F:/Works/2wire_lcd/slcd.c"
#line 224 "F:/Works/2wire_lcd/slcd.c"
sbit clk at RD1_bit;
sbit data_ at RD0_bit;

void IntToLcd(int integer);
void gotoXy(unsigned char ,unsigned char);
void lcdInit(void);
void lcdCmd(unsigned char);
void lcddata_(unsigned char);
void lcdWriteNibble(unsigned char);
void waitLcd(int);
void waitUs(int);
void prints(char *message);

unsigned char rs;
unsigned char msg1[] = "Hello";
unsigned char msg2[] = "Serial";
unsigned char msg3[] = "LCD";
unsigned char msg4[] = "20X4";

void lcdWriteNibble(unsigned char d)
{
unsigned char i;
clk = 0;
data_= 0;
for(i=0;i<8;i++)
 {
 clk = 1;
 clk = 0;
 }

data_ = 1;
clk =1;
clk=0;

data_ = rs;
clk =1;
clk =0;

 for ( i=8;i>0;i=i>>1)
 {
 if(d & i)
 {
 data_ =1;
 }
 else
 {
 data_ =0;
 }

 clk = 1;

 clk = 0;
 }

data_=0;
clk = 1;
clk = 0;


data_ = 1;
data_ = 0;
}


void lcdCmd(unsigned char byte)
{
rs=0;

lcdWriteNibble(byte>>4);
lcdWriteNibble(byte & 0x0F);



}

void lcddata_(unsigned char byte)
{

rs=1;

lcdWriteNibble(byte>>4);

lcdWriteNibble(byte & 0x0F);


}

void lcdInit(void)
{
rs=0;
waitLcd(40);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(5);
lcdWriteNibble(0x03);
waitLcd(2);
lcdWriteNibble(0x02);

lcdCmd(0x28);
waitLcd(50);
lcdCmd(0x0C);
waitLcd(50);
lcdCmd(0x01);
waitLcd(50);
lcdCmd(0x06);
waitLcd(50);
lcdCmd(0x0C);
waitLcd(50);
lcdCmd(0x80);
waitLcd(50);
}

void waitLcd(int x)
{
unsigned char i;
for (x ;x>1;x--)
{
for (i=0;i<=10;i++);
}
}

void waitUs(int x)
{
unsigned char i ;
for (x ;x>1;x--);



}


void gotoXy(unsigned char x,unsigned char y)
{
 if(x<40)
 {
 if(y) x|=0b01000000;
 x|=0b10000000;
 lcdCmd(x);
 }
}







void prints(char *message){

 while (*message){
 lcddata_(*message++);
 }

 }




void IntToLcd(int integer)
{


unsigned char thousands ,hundreds,tens,ones;
thousands = integer / 1000;

 lcddata_(thousands + 0x30);

 hundreds = ((integer - thousands*1000)-1) / 100;

 lcddata_( hundreds + 0x30);
tens=(integer%100)/10;

 lcddata_( tens + 0x30);
 ones=integer%10;

 lcddata_( ones + 0x30);
}


void clearLcd(void)
{

 lcdCmd(0x01);
}



void main() {

 TRISD = 0x00;
 PORTD = 0x00;

 lcdInit();
 gotoXy(3,0);
 prints(&msg1);
 gotoXy(3,1);
 prints(&msg2);
 lcdCmd(0x94);
 prints(&msg3);
 lcdCmd(0xD4);
 prints(&msg4);

 while(1){
 ;
 }

}
